﻿default monster_scale = 6
init python:
    class monster:
        def __init__(self, name, info, front, back, health, damage, speed, moves = None):
            self.name = name
            self.info = info
            self.front = front
            self.back = back
            self.health = health
            self.damage = damage
            self.speed = speed
            self.moves = moves or []

            self.experience = 0
            self.is_alive = True

    class monster_move:
        def __init__(self, name, info, icon):
            self.name = name
            self.info = info
            self.icon = icon

    class monster_player:
        def __init__(self, name, info, image, monsters = None):
            self.name = name
            self.info = info
            self.image = image

            self.monsters = monsters or []
            self.team = []
            self.current = None

            self.x = 0
            self.y = 0
        def summon(self):
            for i in self.monsters:
                if i.is_alive:
                    return i
            else:
                return False

        def add_to_team(self, monster):
            if len(self.team) > 4:
                return
            if monster in self.team:
                return
            self.team.append(monster)

        def remove_from_team(self, monster):
            self.team.remove(monster)

        def catch(self, monster):
            self.monsters.append(monster)

        def release(self, monster):
            self.monsters.append(remove)


    class monster_battle_class:
        def __init__(self, player, enemy):
            self.player = player
            self.enemy = enemy
            self.stage = "start"
        def start(self):
            self.stage = "enemy_summon"
            renpy.notify(1)
        def enemy_summon(self):
            monster = self.enemy.summon()
            if monster:
                self.enemy.current = monster
                self.stage = "player_summon"

        def player_summon(self, monster):
            self.player.current = monster
            self.stage = "playing"


init:
    image kithulu_front:
        Crop((0, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image kithulu_back:
        Crop((0, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image punchrat_front:
        Crop((32, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image punchrat_back:
        Crop((32, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image eyefly_front:
        Crop((64, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image eyefly_back:
        Crop((64, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image goolum_front:
        Crop((96, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image goolum_back:
        Crop((96, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image borny_front:
        Crop((128, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image borny_back:
        Crop((128, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image lil_black_ice_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image lil_black_ice_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image slime_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image slime_ice_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image dandy_lion_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image dandy_lion_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image vilish_front:
        Crop((0, 160, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image vilish_back:
        Crop((0, 192, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

init:
    image blonde:
        Crop((0, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image vi:
        Crop((32, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image barbara:
        Crop((64, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image yari:
        Crop((96, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image blonde_back:
        Crop((128, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image frame_idle:
        Crop((0, 64, 16, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image frame_hover:
        Crop((32, 80, 16, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image mana_bar_full:
        Crop((16, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image mana_bar_empty:
        Crop((16, 80, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image health_bar_full:
        Crop((64, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image health_bar_empty:
        Crop((64, 80, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image arrow:
        Crop((112, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image summon_circle:
        Crop((128, 80, 32, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True


transform character_slide(x, y):
    ease .2 yoffset y
    ease .4 xoffset x
transform summon_circle_animation():
    alpha 0
    pause .4
    ease .2 alpha 0
    ease .2 alpha 1
    ease .2 alpha 0
    ease .2 alpha 1
    ease .2 alpha 0
    ease .2 alpha 1
    ease .4 alpha 0
transform summon_animation():
    yzoom .01 alpha 0
    pause .8
    ease .4 yzoom 1 alpha 1

screen monster_battle_intro(g):
    add g.enemy.image:
        align .5,.5
        if g.enemy.current:
            at character_slide(64*monster_scale, -32*monster_scale)
        else:
            at character_slide(32*monster_scale, -32*monster_scale)

    add g.player.image + "_back":
        align .5,.5
        if g.player.current:
            at character_slide(-64*monster_scale, 32*monster_scale)
        else:
            at character_slide(-32*monster_scale, 32*monster_scale)

    if g.enemy.current:
        fixed:
            fit_first True
            align .5,.5
            offset 32*monster_scale, 0
            add "summon_circle" at summon_circle_animation
            add g.enemy.current.front yanchor 1.0 yoffset 12*monster_scale at summon_animation
    if g.player.current:
        fixed:
            fit_first True
            align .5,.5
            offset -32*monster_scale, 64*monster_scale
            add "summon_circle" at summon_circle_animation
            add g.player.current.back yanchor 1.0 yoffset 12*monster_scale at summon_animation


screen monster_battle_choose(g):
    vbox:
        yalign .5
        for i in g.player.monsters:
            if i.is_alive:
                button:
                    add i.front
                    action Return(i)

screen monster_battle_screen():
    default g = monster_battle_class(
        monster_player("Blonde", "", "blonde"),
        monster_player("Barbara", "", "barbara"),
    )

    if g.player:
        add g.player.image + "_back" align .5,.5:
            at character_slide(-32*monster_scale, 32*monster_scale)
    if g.enemy:
        add g.enemy.image align .5,.5:
            at character_slide(32*monster_scale, -32*monster_scale)


#--------------------------------- Example
default kithulu = monster(
    name = "Kithulu",
    info = "None",
    front = "kithulu_front",
    back = "kithulu_back",
    health = 5, damage = 5, speed = 5,
    )
default punchrat = monster(
    name = "Punch rat",
    info = "None",
    front = "punchrat_front",
    back = "punchrat_back",
    health = 5, damage = 5, speed = 5,
    )
default vilish = monster(
    name = "Punch rat",
    info = "None",
    front = "vilish_front",
    back = "vilish_back",
    health = 5, damage = 5, speed = 5,
    )

label monster_battle_example:
    default battle = monster_battle_class(
        monster_player("Blonde", "", "blonde", [punchrat, kithulu, vilish]),
        monster_player("Barbara", "", "barbara", [punchrat, kithulu, vilish]),
    )

    show screen monster_battle_intro(battle)
    "Get ready."
    $ battle.start()
    "Enemy summons."
    $ battle.enemy_summon()
    "Your turn."
    call screen monster_battle_choose(battle)
    $ battle.player_summon(_return)
    "Let's begin."






